// AqBusDecode.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "PublicLib.h"
#include "AqBusDecode.h"
#include "AqBusDecodeAnalysis.h"
#include "AqBusDecodeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CAqBusDecodeApp

BEGIN_MESSAGE_MAP(CAqBusDecodeApp, CWinApp)
END_MESSAGE_MAP()


// CAqBusDecodeApp construction

CAqBusDecodeApp::CAqBusDecodeApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CAqBusDecodeApp object

CAqBusDecodeApp theApp;

int	giRptField[] = { 50, 50, 50, 0};	// field width of report data
cAqBusDecodeAnalysis *pAqBusDecodeAnalysis = NULL;


// CAqBusDecodeApp initialization

BOOL CAqBusDecodeApp::InitInstance()
{
	pAqBusDecodeAnalysis = new cAqBusDecodeAnalysis;
	CWinApp::InitInstance();

	return TRUE;
}

int CAqBusDecodeApp::ExitInstance()
{
	// TODO: Add your specialized code here and/or call the base class
	delete pAqBusDecodeAnalysis;

	return CWinApp::ExitInstance();
}

// functionBus DecodeTLAD{ϥΡA^Ǩϥγ̤jqDơC
// parameter :
//	int* piMaxCh		: [O] qDs̤jh. (ҦpDSOuBz6ӳqD), J-1NHLA
//	char *szName		: [O] W
//	int iNameBufSize	: [I] szNamesize
//	int** piRptField	: [O] Reporteת, ̫@ӻݬs. ҦpProtocolT: 100, 150, 120, 0
// return :
//	^Ǩϥγ̤jqD
int _GetDecodeInfo(int* piMaxCh, char *szName, int iNameBufSize, int** piRptField)
{
	*piMaxCh = -1;
	strcpy_s( szName, iNameBufSize, "<Bus Decode>" );
	*piRptField = giRptField;
	return 2;	// iChs, ϥγqD
}

// function \ରi Protocol Ru@,
// ̫إߤRƤ Boundary/Data arrayCarrayƻݫOsDLL
// Parameter :
//	LPDECODECFG lpDecodeCfg	: [I] decode config
//	I64 **pi64RetBoundary	: [O] Boundary array
//	UINT **pnRetData		: [O] Data array
// return :
//	size of array
int _Analysis(LPDECODECFG lpDecodeCfg, I64 **pi64RetBoundary, UINT **pnRetData)
{
	int iSize;

	pAqBusDecodeAnalysis->Analysis(lpDecodeCfg);

	*pi64RetBoundary = pAqBusDecodeAnalysis->m_iaBoundary.GetData();
	*pnRetData = pAqBusDecodeAnalysis->m_iaData.GetData();

	iSize = (int)pAqBusDecodeAnalysis->m_iaBoundary.GetSize();

	return iSize;	// Analysis禡Ǧ^RXӪƤjp
}

// function \ର Protocol R, ̷Boundary/Data arrayReport
// ̫ᲣͤRƤ Report DataC
// Parameter :
//	LPDECODECFG lpDecodeCfg	: [I] decode config
//	I64 *pi64RetBoundary	: [I] Boundary array
//	UINT *pnRetData			: [I] Data array
//	int iRetDataSize		: [I] Size of array
BOOL _BuildReport(LPDECODECFG lpDecodeCfg, I64 *pi64RetBoundary, UINT *pnRetData, int iRetDataSize)
{
	pAqBusDecodeAnalysis->BuildCSV(lpDecodeCfg, pi64RetBoundary, pnRetData, iRetDataSize);

	return TRUE;
}

// function \ണܩiΰϪr,
// LA Viewer |eeWRƤ Data ǤJC
// Parameter :
//	LPDECODECFG lpDecodeCfg	: [I] decode config
//	int *piData				: [I] Data ValueơA1stslengthC
//	char *pszBuf			: [O] xsܩiΰϤrƪwİϦ}C
//	int iBufSize			: [I] pszBufҰѦҤwİϤjpC
//	int *iColorIdx			: [O] Ǧ^ХܪCN(0-15, -1NХC)
BOOL _DataConv(LPDECODECFG lpDecodeCfg, int *piData, char *pszBuf, int iBufSize, int *piColorIdx)
{
	pAqBusDecodeAnalysis->ConvertMsg(lpDecodeCfg, piData, pszBuf, iBufSize, piColorIdx);

	return TRUE;
}

// function \O^ǳqDW, HKLA Viewer ܩeWC
// Parameter :
//	LPDECODECFG lpDecodeCfg	: [I] decode config
//	int iChIdx				: [I] qDsC
//	char *pszBuf			: [O] xsqDW٤wİϦ}C
//	int iBufSize			: [I] pszBufҰѦҤwİϤjpC
BOOL _ChannelName(LPDECODECFG lpDecodeCfg, int iChIdx, char *pszBuf, int iBufSize)
{
	if( iChIdx == 0 )
		strcpy_s(pszBuf, iBufSize, _T("CLK"));
	else if( iChIdx == 1 )
		strcpy_s(pszBuf, iBufSize, _T("DAT"));
	else
		sprintf_s(pszBuf, iBufSize, "%d", lpDecodeCfg->iCh[iChIdx]);

	return TRUE;
}

// function \ରֳt Settings, |} Settings DialogC
// Parameter :
//	LPDECODECFG lpDecodeCfg	: [I/O] decode config
void _DefaultSetting(LPDECODECFG lpDecodeCfg)
{
	cAqBusDecodeDlg dlg(lpDecodeCfg);
	dlg.DefaultSettings();
}

// function \O} Settings e,
// J Bus decode ݭnϥΪ̨Mw	Ѽ. Bus decode bq} Settings dialogHK󱵦]wѼơC
// Parameter :
//	LPDECODECFG lpDecodeCfg	: [I/O] decode config
void _SettingsDialog(LPDECODECFG lpDecodeCfg)
{
	cAqBusDecodeDlg dlg(lpDecodeCfg);
	dlg.DoModal();
}

// function \O Protocol ^ display name
BOOL _GetDisplayName(char* pNameBuf, int iBufSize)
{	
	strcpy_s(pNameBuf, iBufSize, "" );
	return true;	
}


// tX QuickSet, ݶJ LA  default Ѽ.
// Lצp, dwLAChNum @wnqD.
// Parameter :
//		DWORD* pdwLAChNum: [I/O] ^Ǧ decode һ LA qD
//		DWORD* pdwLAThres: [I/O] ^Ǧ decode w] LA Threshold, O mV
//		DWORD* pi64LASR  : [I/O] ^Ǧ decode w] LA Sample rate, O Hz. Y 0 
//				   		          Υثḛ sample rate
BOOL _GetLAQuickSetInfo(DWORD* pdwLAChNum, DWORD* pdwLAThres, INT64* pi64LASR)
{
	*pdwLAChNum = 2;
	*pdwLAThres = 1600; // 1.6V
    *pi64LASR = 0;
	return true;
}

// tX QuickSet, ݶJ DSO  default Ѽư򥻸.
// Lצp, pdwDSOChNum @wnqD.
// Parameter :
//		DWORD* pdwLAChNum: [I/O]      ^Ǧ decode һ DSO qD
//				                      YS, Ц^ 0.  return false
//		DWORD* pdwDSOFreqInKHz: [I/O] ^Ǧ decode w] DSO Sample rate, O KHz. 
//				                      i 0
BOOL _GetDSOQuickSetInfo(DWORD* pdwDSOChNum, DWORD* pdwDSOFreqInKHz)
{
	return false;
}


// tX QuickSet, Ywg^ DSO Channel number , NJ
// n۰ʷsWqDW
// Parameter :
//		int iIdx: [I]			qD,  0 }l
//		char* pChNameBuf: [I/O] ^ǳqDW string buffer
//		int iBufSize: [I] ^ǳqDW string buffer size
BOOL _GetDSOQuickSetInfoName(int iIdx, char* pChNameBuf, int iBufSize)
{	
	return false;
}



