#pragma once
#include "PublicLib.h"

// cAqBusDecodeDlg dialog

class cAqBusDecodeDlg : public CDialog
{
	DECLARE_DYNAMIC(cAqBusDecodeDlg)

public:
	cAqBusDecodeDlg(LPDECODECFG lpDecodeCfg, CWnd* pParent = NULL);   // standard constructor
	virtual ~cAqBusDecodeDlg();
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	void DefaultSettings(void);
	void UpdateSpin2Edit(CStatic* pstCh, int iVal);
	void UpdateSpin2Edit(void);
	afx_msg void OnDeltaposSpclk(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposSpdata(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedDefault();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();

	CStatic m_bmpPara;
	CStatic m_bmpColor;
	CStatic m_bmpRange;
	CButton m_bnCancel;

	CComboBox m_Begin;
	CComboBox m_End;

	CStatic m_stChClk;
	CStatic m_stChData;
	CSpinButtonCtrl m_spChClk;
	CSpinButtonCtrl m_spChData;

	CColorPicker m_cbColor01;
	CColorPicker m_cbColor02;
	CColorPicker m_cbColor03;

	CColorPicker *m_cbColor[COLOR_COUNT];

// Dialog Data
	enum { IDD = IDD_DLGBUSDECODE };

private:
	LPDECODECFG m_lpDecodeCfg;
	cAqBusDecodeSetting* m_pAqBusDecodeSetting;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
};
